/*  File:     cnctClient.java 
    Project:  OOPracktikum 2001
	            Connect-Game Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Autor:
    Descript: Connect-SpielClient
              Diese Klasse bildet die Applikation 
    last mod: Mon Apr 30 23:28:27 CEST 2001   
*/


import java.awt.Frame;
import java.awt.event.*;
import java.awt.*;
import java.awt.MenuBar;
//import javax.swing.*;

import cnctSocket.*;
import cnctGameClientPack.*;
import cnctClientCallerInterface;

public class cnctClient extends Frame //Patch
{
  private cnctClientCallerInterface parent;
  private cnctClientPanel panel;
  private Menu menu1,menu2,menu3,menu4;
  private MenuBar menubar;
  private MenuItem beenden,aufgeben,hilfe,wir;
  private point size;
  private cnctClientMessage nachricht;
  
  // Fenster initialisieren
  public cnctClient( cnctClientCallerInterface _parent,String host, int port, String name){
    setTitle("Connect-Spiel-Client-0.0.1  " + name);
    size=new point(500,700);
    setSize(size.x,size.y);
    setLocation(100,100);
    parent=_parent;
    
    // Event einbauen fr Fenster schliessen
    addWindowListener(new WindowAdapter(){
      public void windowClosing(WindowEvent e){
          close();
    	}
    });
    
///////////////////////////////////////////    Patrick Menu //////////////////////////////////////////////////////    

    // Menu erstellen hinzufuegen
    menu1=new Menu("Aktionen");
  //  menu2=new Menu("Hilfe");
  //  menu3=new Menu("Producers");
    
    aufgeben=new MenuItem("Aufgeben");    
    beenden=new MenuItem("Quit");
  //  hilfe=new MenuItem("HILFEEE");
  //  wir=new MenuItem("ueber uns..");
    
    menubar=new MenuBar();
    
    // Panel hinzufuegen
    panel=new cnctClientPanel(size, host, port, name);
    setTitle("Connect-Spiel-Client-0.0.1     " + name + " vs. " + panel.getOppositeName());
    add(panel);
    menubar.add(menu1);
  //  menubar.add(menu2);
  //  menubar.add(menu3);
    setMenuBar(menubar);
    menu1.add(beenden);
    menu1.add(aufgeben);
  //  menu2.add(hilfe);
  //  menu3.add(wir);    
    
    beenden.addActionListener(new ActionListener(){ 
	    public void actionPerformed(ActionEvent e){
            close();
		  }
	    });
    
    
    aufgeben.addActionListener(new ActionListener(){ public void actionPerformed(ActionEvent e){
	if(panel.socket.resign()){
    	    panel.messages.addMessage("Jetzt habe ich aufgegeben!!!!",cnctClientMessage.INFO);
	}else{
	    panel.messages.addMessage("Momentan kann nicht aufgegeben werden",cnctClientMessage.ERROR);
	}	 
	panel.repaint();
    }});

  }
  
  //--------------------------------------------------------
  public void close(){
		    panel.close();
        	    if(parent == null){
        			System.exit(0);
        	    }else{
	        	parent.closeclient();
		    }
    
  }  
  
  
  //--------------------------------------------------------
  // MAIN
  public static void main(String[] args)
    {
      String host=new String("theopc.informatik.uni-leipzig.de");
      String name=new String("craftsman");
      int port=9001;
      if(args.length>1){
        Integer tempport;
        host = new String(args[0]);
        tempport=new Integer(args[1]);
	port=tempport.intValue();
      }
      if(args.length==3 || args.length==1){
	     name=args[args.length-1];      
      }
      
      if(args.length<1 || args.length>3)System.out.println("Usage: java cnctClient {host port name | name }");
	  System.out.println("I use host: "+host + " port: "+ port + " and Name:" + name);
           
      
      cnctClient  frame = new cnctClient(null, host, port, name);
      frame.show();
    }
}

