/*  File:     cnctInfoGameList.java 
    Project:  OOPracktikum 2001
	            Connect-Game Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Package:  cnctInfoSocket
    Autor:    
    Descript: Eine Liste (Vektor) vom Playern mit seinem Status
    last mod: Mon Apr 30 23:28:27 CEST 2001
*/

package cnctInfoSocket;

import java.io.*;
import java.net.*;
import java.util.Vector;

import cnctParser.*;

public class cnctInfoGameList extends Vector{
    
   //------------------------------------------------------
    public cnctInfoGameList(){
      super();
    };
  
  //------------------------------------------------	
  //(Start{schwarz="Name1",weiss="Name1",size=13,status=(Waiting_for Schwarz)|Done|Running,von="Wed Jun 27 17:09:01 CEST 2001",bis="",
  //    gewinner=Nothing|(Just Weiss|Schwarz)});
 
  public boolean analyseSyntaxAndAdd(knoten syntax, int number) throws cnctSocketException{
    int i;
	int listcounter;
	knoten subknoten;  
    knoten value;
    cnctInfoGame game = new cnctInfoGame();
	game.setGameNumber(number);
  
    if(syntax.getTyp()!=knoten.TUPEL){ // Fehler      
	   throw new cnctSocketException("Game mu TUPEL sein"); 
    }
    
    syntax=syntax.getKind(0);
	
    if(syntax.getTyp()!=knoten.KONSTRUKTOR){ // Fehler      
	   throw new cnctSocketException("Game mu (Start{}) sein"); 
    }
	
	syntax=syntax.getKind(0);
	if(syntax.getTyp()!=knoten.RECORD || syntax.compareName("Start")){ // Fehler      
	   throw new cnctSocketException("Game mu (Start{}) sein"); 
    }
	
	for(i=0;i<syntax.getKinderZahl();i++){

      subknoten=syntax.getKind(i);
      if(subknoten== null || subknoten.getTyp() == knoten.LEER) continue; 
	  value=subknoten.getKind(0);
      if(subknoten.compareName("size")){
          game.setSize(value.getZahl());
      }else
      if(subknoten.compareName("status")){
	      if(value.getTyp()==knoten.KONSTRUKTOR){  // entweder Done oder Running 
          	game.setStatus(value.getName());
      	  }else if(value.getTyp()==knoten.TUPEL){ //(Waiting_for Schwarz)
		    
		    game.setStatus(value.getKind(0).getName());
		  }
      }else
      if(subknoten.compareName("gewinner")){
    	if(value.getTyp()==knoten.KONSTRUKTOR){// mu Nothing sein
		   game.setWinner(value.getName());  
		}else if(value.getTyp()==knoten.TUPEL){//(JUST Farbe)
		  value=value.getKind(0);
		  if(value.getTyp()==knoten.KONSTRUKTOR){
		    game.setWinner(value.getKind(0).getName());
		  }	
		}
		
      }      

    }


      addElement(game);

	  return true;
  }; 
  
  public void printGames(){
    for(int i=0 ; i < size(); i++){
      System.out.println("Nummer: " + ((cnctInfoGame)elementAt(i)).getGameNumber() + "\tStatus: " + ((cnctInfoGame)elementAt(i)).getStatusString() + "\t Size: " + ((cnctInfoGame)elementAt(i)).getSize());   
    }
  }
  
   
  
}
