/*  File:     cnctInfoPlayerList.java 
    Project:  OOPracktikum 2001
	            Connect-Game Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Package:  cnctInfoSocket
    Autor:    
    Descript: Eine Liste (Vektor) vom Playern mit seinem Status
    last mod: Mon Apr 30 23:28:27 CEST 2001
*/

package cnctInfoSocket;

import java.io.*;
import java.net.*;
import java.util.Vector;

import cnctParser.*;

public class cnctInfoPlayerList extends Vector{ 

  /////////////////////////////////////////// F U N K T I O N E N ///////////////////////////
  //  public cnctInfoPlayerList();
  //####findet schliessende Klammer zu der gerade aufgegangenen
  //  public boolean analyseSyntaxAndAdd(knoten syntax) throws cnctSocketException;
  
  /////////////////////////////////////////// I M P L E M E N T I E R U N G ///////////////////////////
   
  //-------------------------------
  public cnctInfoPlayerList(){
    super();
  }
	

  //------------------------------------------------	
  //Idle;
  //(Engaged{role= Waiting|Running|Watching, game=1,farbe=Schwarz})
  
  public boolean analyseSyntaxAndAdd(knoten syntax, String playername) throws cnctSocketException{
    int i;
	int listcounter;
	knoten subknoten;  
    knoten value;
    cnctInfoPlayer player = new cnctInfoPlayer();
    player.setName(playername);
	
      if(syntax.getTyp()==knoten.KONSTRUKTOR){ // muss Idle sein
          if(!player.setStatus(syntax.getName())){ 
             System.out.println("Unkekannter Status: " + syntax.getName());  
             return false;
          }
      
      }else
      if(syntax.getTyp()==knoten.TUPEL){ // muss Engaged sein
        syntax=syntax.getKind(0);
        if(syntax.getTyp()==knoten.KONSTRUKTOR && syntax.compareName("Engaged")){
          syntax=syntax.getKind(0);
          if(syntax.getTyp()!=knoten.RECORD) {
             System.out.println("Record bei Engaged erwartet ");
             return false;  
          }
          for(i=0;i<syntax.getKinderZahl();i++){
            subknoten=syntax.getKind(i);
            if(subknoten== null || subknoten.getTyp() == knoten.LEER) continue; 
            value=subknoten.getKind(0);
            if(subknoten.compareName("role")){
                player.setStatus(value.getName());
            }else
            if(subknoten.compareName("game")){
                player.setGameNumber(value.getZahl());
            }else
            if(subknoten.compareName("color")){
              if(value.getTyp()==knoten.KONSTRUKTOR)  
                player.setColor(value.getKind(0).getName());
            }      
          }          
        }else{
          System.out.println("Unkekannter SyntaxTyp bzw Status ");
          syntax.printBaum(0,false);  
          return false;
        }
      }else{
          System.out.println("Unkekannter SyntaxTyp: ");
          syntax.printBaum(0,false);  
          return false;
      }


      addElement(player);

	  return true;
  }; 
  
  public void printPlayer(){
    for(int i=0 ; i < size(); i++){
      System.out.println("Name: " + ((cnctInfoPlayer)elementAt(i)).getName() + "\tStatus: " + ((cnctInfoPlayer)elementAt(i)).getStatus() + "\t Spielnummer: " + ((cnctInfoPlayer)elementAt(i)).getGameNumber() + "\t Farbe: " + ((cnctInfoPlayer)elementAt(i)).getColor());   
    }
  }
  
}
